
(function () {
    if (typeof window.jsb === 'object') {
        var hotUpdateSearchPaths = localStorage.getItem('FourHotUpdateSearchPaths');
        if (hotUpdateSearchPaths) {
            var paths = JSON.parse(hotUpdateSearchPaths);
            jsb.fileUtils.setSearchPaths(paths);
        
            var fileList = [];
            var storagePath = paths[0] || '';
            var tempPath = storagePath + '_temp/';
            var baseOffset = tempPath.length;

            if (jsb.fileUtils.isDirectoryExist(tempPath) && !jsb.fileUtils.isFileExist(tempPath + 'project.manifest.temp')) {
                jsb.fileUtils.listFilesRecursively(tempPath, fileList);
                fileList.forEach(srcPath => {
                    var relativePath = srcPath.substr(baseOffset);
                    var dstPath = storagePath + relativePath;

                    if (srcPath[srcPath.length] == '/') {
                        cc.fileUtils.createDirectory(dstPath)
                    }
                    else {
                        if (cc.fileUtils.isFileExist(dstPath)) {
                            cc.fileUtils.removeFile(dstPath)
                        }
                        cc.fileUtils.renameFile(srcPath, dstPath);
                    }
                })
                cc.fileUtils.removeDirectory(tempPath);
            }
        }
    }
})();

window.boot = function () {
    var settings = window._CCSettings;
    window._CCSettings = undefined;

    let {RESOURCES, INTERNAL, MAIN, START_SCENE} = cc.AssetManager.BuiltinBundleName;
    var onStart = function () {
        cc.view.enableRetina(true);
        cc.view.resizeWithBrowserSize(true);

        cc.view.setOrientation(cc.macro.ORIENTATION_PORTRAIT);

        if (cc.sys.isBrowser && cc.sys.os === cc.sys.OS_ANDROID) {
            cc.assetManager.downloader.maxConcurrency = 2;
            cc.assetManager.downloader.maxRequestsPerFrame = 2;
        }

        var curType = 0;
        if (cc.sys.os == cc.sys.OS_ANDROID) {
            curType = jsb.reflection.callStaticMethod("org/cocos2dx/lib/Cocos2dxActivity", "getGameType", "()I");
        } else if (cc.sys.os == cc.sys.OS_IOS) {
            curType = jsb.reflection.callStaticMethod("VoiceRoomHelper", "getGameType");
        }
        var launchScene = settings.launchScene;
        if (curType > 4000 && curType <= 5000) {
            launchScene = "db://assets/scenes/voiceScene.fire";
        }
        var bundle = cc.assetManager.bundles.find(function (b) {
            return b.getSceneInfo(launchScene);
        });
        if (bundle == null) {
            let headPathPre = ((jsb.fileUtils ? jsb.fileUtils.getWritablePath() : '/') + "head-remote-asset" + "-pre");
            let headPath = ((jsb.fileUtils ? jsb.fileUtils.getWritablePath() : '/') + "head-remote-asset");
            jsb.fileUtils.removeDirectory(headPathPre);
            jsb.fileUtils.removeDirectory(headPath);
            launchScene = settings.launchScene;
            bundle = cc.assetManager.bundles.find(function (b) {
                return b.getSceneInfo(launchScene);
            });
            
            var callBack = function() {
                UIUtils.unListenEvt("startUpdateGameData", callBack, null);
                cc.game.restart();
            }
            
            UIUtils.listenEvt("startUpdateGameData", callBack, null);
        }

        // load scene
        bundle.loadScene(launchScene, null, null,
            function (err, scene) {
                if (!err) {
                    cc.director.runSceneImmediate(scene);
                }
            }
        );
    };

    var option = {
        id: 'GameCanvas',
        debugMode: settings.debug ? cc.debug.DebugMode.INFO : cc.debug.DebugMode.ERROR,
        showFPS: false,
        frameRate: 60,
        groupList: settings.groupList,
        collisionMatrix: settings.collisionMatrix,
    };

    cc.assetManager.init({ 
        bundleVers: settings.bundleVers,
        remoteBundles: settings.remoteBundles,
        server: settings.server
    });
    
    let bundleRoot = [INTERNAL, MAIN];
    settings.hasStartSceneBundle && bundleRoot.push(START_SCENE);
    settings.hasResourcesBundle && bundleRoot.push(RESOURCES);

    var count = 0;
    function cb (err) {
        if (err) return console.error(err.message, err.stack);
        count++;
        if (count === bundleRoot.length + 1) {
            cc.game.run(option, onStart);
        }
    }

    cc.assetManager.loadScript(settings.jsList.map(function (x) {return 'src/' + x;}), cb);

    for (let i = 0; i < bundleRoot.length; i++) {
        cc.assetManager.loadBundle(bundleRoot[i], cb);
    }
};

if (window.jsb) {
    require('src/settings.js');
    require('src/cocos2d-jsb.js');
    require('jsb-adapter/jsb-engine.js');

    cc.macro.CLEANUP_IMAGE_CACHE = true;
    window.boot();
}
